<ui:composition xmlns:g="http://www.ihe.net/gazelle" xmlns:a4j="http://richfaces.org/a4j"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:rich="http://richfaces.org/rich" xmlns:c="http://java.sun.com/jstl/core"
                xmlns:s="http://jboss.org/schema/seam/taglib" xmlns:h="http://java.sun.com/jsf/html"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        <h2>#{messages['net.ihe.gazelle.xval.EditXValidator']}</h2>
        <s:div id="notallowedAction"
               rendered="#{xvalidatorEditorManager.validator.isDeprecated() or xvalidatorEditorManager.validator.isAvailable()}">
            <h:outputText value="#{messages['net.ihe.gazelle.xval.YouAreNotAllowedToUpdateThisValidatorBecauseItIs']}"
                          styleClass="message"/>
        </s:div>
        <s:div id="globalDiv"
               rendered="#{xvalidatorEditorManager.validator.isUnderDevelopment() or xvalidatorEditorManager.validator.isUnderMaintenance()}">
            <h:form id="generalInfoForm">
                <ui:decorate template="/layout/panels/_panel_title_footer_id.xhtml">
                    <ui:param name="panel_id" value="descriptionPanel"/>
                    <ui:define name="panel_title">
                        <h:outputText value="#{messages['net.ihe.gazelle.xval.GazelleCrossValidatorDescription']}"/>
                    </ui:define>
                    <div class="row">
                        <div class="col-md-4">
                            <s:div rendered="#{xvalidatorEditorManager.validator.isUnderDevelopment()}"
                                   id="underDevDiv">
                                <s:decorate template="/layout/form/_edit.xhtml">
                                    <ui:param name="id" value="nameInput"/>
                                    <ui:define name="label">#{messages['net.ihe.gazelle.xval.Name']}</ui:define>
                                    <h:inputText value="#{xvalidatorEditorManager.validator.name}" required="true"
                                                 requiredMessage="A name is required for this validator"
                                                 id="nameInput" styleClass="form-control"
                                                 validator="#{xvalidatorEditorManager.validateValidatorName}"/>
                                </s:decorate>
                                <s:decorate template="/layout/form/_edit.xhtml">
                                    <ui:param name="id" value="domainInput"/>
                                    <ui:define name="label">#{messages['net.ihe.gazelle.xval.AffinityDomain_2']}
                                    </ui:define>
                                    <!-- we may want to use the same as one already registered -->
                                    <rich:autocomplete autofill="true" id="domainInput"
                                                       value="#{xvalidatorEditorManager.validator.affinityDomain}"
                                                       autocompleteList="#{xvalidatorEditorManager.getAvailableAffinityDomains()}"
                                                       mode="client" required="true"
                                                       requiredMessage="The affinity domain is a mandatory field"
                                                       selectFirst="true" layout="list"/>
                                </s:decorate>
                                <s:decorate template="/layout/form/_edit.xhtml">
                                    <ui:param name="id" value="versionInput"/>
                                    <ui:define name="label">#{messages['net.ihe.gazelle.xval.Version']}</ui:define>
                                    <h:inputText value="#{xvalidatorEditorManager.validator.version}"
                                                 required="true" id="versionInput" styleClass="form-control"
                                                 requiredMessage="A version is required for this validator"/>
                                </s:decorate>
                                <s:decorate template="/layout/form/_edit.xhtml">
                                    <ui:param name="id" value="oid"/>
                                    <ui:define name="label">#{messages['net.ihe.gazelle.xval.OID']}</ui:define>
                                    <h:inputText value="#{xvalidatorEditorManager.validator.oid}"
                                                 id="oid" styleClass="form-control" disabled="true"/>
                                </s:decorate>
                            </s:div>
                            <s:div rendered="#{not xvalidatorEditorManager.validator.isUnderDevelopment()}">
                                <dl>
                                    <s:decorate template="/layout/display/_data_list_item.xhtml">
                                        <ui:define name="label">#{messages['net.ihe.gazelle.xval.Name']}</ui:define>
                                        <h:outputText value="#{xvalidatorEditorManager.validator.name}"/>
                                    </s:decorate>
                                    <s:decorate template="/layout/display/_data_list_item.xhtml">
                                        <ui:define name="label">#{messages['net.ihe.gazelle.xval.AffinityDomain_2']}
                                        </ui:define>
                                        <h:outputText value="#{xvalidatorEditorManager.validator.affinityDomain}"/>
                                    </s:decorate>
                                    <s:decorate template="/layout/display/_data_list_item.xhtml">
                                        <ui:define name="label">#{messages['net.ihe.gazelle.xval.Version']}</ui:define>
                                        <h:outputText value="#{xvalidatorEditorManager.validator.version}"/>
                                    </s:decorate>
                                    <s:decorate template="/layout/display/_data_list_item.xhtml">
                                        <ui:define name="label">#{messages['net.ihe.gazelle.xval.OID']}</ui:define>
                                        <h:outputText value="#{xvalidatorEditorManager.validator.oid}"/>
                                    </s:decorate>
                                </dl>
                            </s:div>
                            <dl>
                                <s:decorate template="/layout/display/_data_list_item.xhtml" id="statusDecorate">
                                    <ui:define name="label">#{messages['net.ihe.gazelle.xval.Status']}</ui:define>
                                    <h:outputText value="#{xvalidatorEditorManager.validator.status.value}"/>
                                </s:decorate>
                                <s:decorate template="/layout/display/_data_list_item.xhtml"
                                            rendered="#{not empty xvalidatorEditorManager.validator.lastModifiedDate}">
                                    <ui:define name="label">#{messages['net.ihe.gazelle.xval.LastModifiedOn']}
                                    </ui:define>
                                    <g:date value="#{xvalidatorEditorManager.validator.lastModifiedDate}"/>
                                </s:decorate>
                                <s:decorate template="/layout/display/_data_list_item.xhtml"
                                            rendered="#{not empty xvalidatorEditorManager.validator.lastModifier}">
                                    <ui:define name="label">#{messages['net.ihe.gazelle.xval.LastModifiedBy']}
                                    </ui:define>
                                    <h:outputText value="#{xvalidatorEditorManager.validator.lastModifier}"/>
                                </s:decorate>
                            </dl>
                            <s:decorate template="/layout/form/_edit.xhtml">
                                <ui:param name="id" value="descInput"/>
                                <ui:define name="label">#{messages['net.ihe.gazelle.xval.Description']}</ui:define>
                                <h:inputTextarea value="#{xvalidatorEditorManager.validator.description}"
                                                 required="true" style="resize:both" id="descInput"
                                                 styleClass="form-control"
                                                 requiredMessage="A description is required for this validator"/>
                            </s:decorate>
                        </div>
                        <s:div styleClass="col-md-8" rendered="#{xvalidatorEditorManager.validator.id != null}">
                            <!-- <ui:include src="/xvalidation/common/_validatorPies.xhtml">
                                 <ui:param name="currentVal" value="#{xvalidatorEditorManager.validator}"/>
                             </ui:include>-->
                        </s:div>
                    </div>
                    <ui:define name="panel_footer">
                        <a4j:commandButton value="#{messages['net.ihe.gazelle.xval.Back']}"
                                           action="#{xvalidatorEditorManager.cancel()}" bypassUpdates="true"
                                           immediate="true" styleClass="gzl-btn"
                                           title="#{messages['net.ihe.gazelle.xval.UnsavedChangesWillBeLost_2']}"/>
                        <a4j:commandButton value="#{messages['net.ihe.gazelle.xval.Save']}"
                                           actionListener="#{xvalidatorEditorManager.save()}"
                                           render="globalDiv generalInfoForm configurationPanel configForm listParent addParentForm newInputForm newValidatedObjectsPanel validatorInputsForm,
                                           addRuleForm inheritedRuleForm"
                                           styleClass="gzl-btn-green"/>
                        <div class="btn-group">
                            <button type="button" class="btn gzl-btn-blue dropdown-toggle" data-toggle="dropdown"
                                    aria-haspopup="true" aria-expanded="false">#{messages['net.ihe.gazelle.xval.MarkAs']} <span class="caret"/>
                            </button>
                            <ul class="dropdown-menu">
                                <li>
                                    <a4j:commandLink
                                            value="#{messages['net.ihe.gazelle.xval.AvailableForTesting']}"
                                            oncomplete="jq162('#availableValidatorPanel').modal('show');"
                                            rendered="#{xvalidatorEditorManager.validator.id != null and xvalidatorEditorManager.isValidatorReady()}"
                                            render="availableValidatorPanelContent"/>
                                </li>
                                <li>
                                    <a4j:commandLink value="#{messages['net.ihe.gazelle.xval.Deprecated']}"
                                                     action="#{xvalidatorEditorManager.deprecateValidator()}"
                                                     immediate="true"
                                                     rendered="#{xvalidatorEditorManager.validator.id != null}"
                                                     execute="@this"/>
                                </li>
                            </ul>
                        </div>
                        <div class="btn-group">
                            <button type="button" class="btn gzl-btn-blue dropdown-toggle" data-toggle="dropdown"
                                    aria-haspopup="true" aria-expanded="false">#{messages['net.ihe.gazelle.xval.UnitTesting']} <span class="caret"/>
                            </button>
                            <ul class="dropdown-menu">
                                <li>
                                    <a4j:commandLink value="#{messages['net.ihe.gazelle.xval.AccessUnitTests']}"
                                                     action="#{ruleUnitTestManager.displayUnitTestsForValidator(xvalidatorEditorManager.validator)}"
                                                     bypassUpdates="true" immediate="true"
                                                     title="#{messages['net.ihe.gazelle.xval.UnsavedChangesWillBeLost_2']}"/>
                                </li>
                                <li>
                                    <a4j:commandLink value="#{messages['net.ihe.gazelle.xval.ExecuteUnitTests']}"
                                                     action="#{ruleUnitTestManager.executeUnitTestsForValidator(xvalidatorEditorManager.validator)}"
                                                     bypassUpdates="true" immediate="true"
                                                     title="#{messages['net.ihe.gazelle.xval.UnsavedChangesWillBeLost_2']}"/>
                                </li>
                            </ul>
                        </div>
                    </ui:define>
                </ui:decorate>
            </h:form>
            <s:div id="complementaryInfoDiv" rendered="#{xvalidatorEditorManager.validator.id != null}">
                <ui:decorate template="/layout/panels/_panel_title_id.xhtml">
                    <ui:param name="panel_id" value="parents"/>
                    <ui:define name="panel_title">
                        <h:outputText value="#{messages['net.ihe.gazelle.xval.Inheritance']}"/>
                    </ui:define>
                    <dl>
                        <s:decorate template="/layout/display/_display.xhtml" id="validatorParentDecorate">
                            <ui:define name="id" value="parentInput"/>
                            <ui:define name="label">#{messages['net.ihe.gazelle.xval.InheritRulesFrom']}</ui:define>
                            <h:form id="listParent">
                                <rich:tree id="treeOfParents" value="#{xvalidatorEditorManager.buildTree()}" var="node"
                                           style="vertical-align:top"
                                           rowKeyConverter="org.richfaces.IntegerSequenceRowKeyConverter"
                                           adviseNodeOpened="#{xvalidatorEditorManager.adviseNodeOpened}"
                                           adviseNodeSelected="#{xvalidatorEditorManager.adviseNodeSelected}"
                                           selectionType="client" execute="@this" toggleType="client">
                                    <rich:treeNode expanded="#{true}">
                                        <g:link value="#{node.data}"/>
                                        <a4j:commandLink
                                                actionListener="#{xvalidatorEditorManager.removeParent(node.data)}"
                                                immediate="true" execute="@this" rendered="#{xvalidatorEditorManager.isDirectValidatorParent(node, node.data)}"
                                                render="globalDiv listParent addParentForm newInputForm validatorInputsForm
                                                    addRuleForm inheritedRuleForm deprecatedValidatorForm"
                                                title="#{messages['net.ihe.gazelle.xval.Remove']}">
                                            <s:span styleClass="fa fa-trash-o gzl-text-red"/>
                                        </a4j:commandLink>
                                    </rich:treeNode>
                                </rich:tree>
                            </h:form>
                        </s:decorate>
                    </dl>
                    <h:form id="addParentForm">
                        <h:selectOneMenu id="menuParent" value="#{xvalidatorEditorManager.parentToAdd}"
                                         valueChangeListener="#{xvalidatorEditorManager.onSelectParentListener}"
                                         styleClass="form-control gzl-form-control gzl-select-text">
                            <s:selectItems value="#{xvalidatorEditorManager.availableValidators()}" var="val"
                                           label="#{val.affinityDomain} - #{val.name}"
                                           noSelectionLabel="#{messages['net.ihe.gazelle.xval.PleaseSelect']}"/>
                            <a4j:ajax event="change"
                                      render="globalDiv parents listParent rulesPanel inheritedRulesDecorate validatedObjectsPanel
                                      deprecatedValidatorForm validatorInputsForm addRuleForm"/>
                        </h:selectOneMenu>
                    </h:form>
                    <br/>
                    <h:form id="deprecatedValidatorForm">
                        <rich:panel styleClass="gzl-alert gzl-alert-red"
                                    rendered="#{not empty xvalidatorEditorManager.deprecatedValidatorParentsName}" id="deprecatedValidatorPanel">
                            <span class="gzl-icon-exclamation-triangle"/>
                            <h:outputText
                                    value="#{messages['net.ihe.gazelle.xval.FollowingValidatorsAreDeprecatedAndDirectlyindir']}"/>
                            <br/>
                            <br/>
                            <c:forEach items="#{xvalidatorEditorManager.deprecatedValidatorParentsName}" var="deprecatedValidatorParentName">
                                <h:outputText value="#{deprecatedValidatorParentName}"/>
                                <br/>
                                <br/>
                            </c:forEach>
                        </rich:panel>
                    </h:form>
                </ui:decorate>
                <h:form id="configForm">
                    <ui:decorate template="/layout/panels/_panel_title_footer_id.xhtml">
                        <ui:param name="panel_id" value="configurationPanel"/>
                        <ui:define name="panel_title">
                            <h:outputText value="#{messages['net.ihe.gazelle.xval.ValidatorConfiguration']}"/>
                        </ui:define>
                        <s:decorate template="/layout/form/_edit.xhtml">
                            <ui:param name="id" value="amurlInput"/>
                            <ui:define name="label">#{messages['net.ihe.gazelle.xval.AssertionManagerURL']}</ui:define>
                            <h:inputText
                                    value="#{xvalidatorEditorManager.validator.configuration.assertionManagerUrl}"
                                    id="amurlInput" styleClass="form-control"/>
                            <s:span styleClass="fa fa-info help-block">
                                <h:outputText
                                        value=" #{messages['net.ihe.gazelle.xval.URLOfTheAssertionManagerInstanceWhichHoldsTheAss']}"/>
                            </s:span>
                        </s:decorate>
                        <s:decorate template="/layout/form/_edit.xhtml">
                            <ui:param name="id" value="dicomInput"/>
                            <ui:define name="label">#{messages['net.ihe.gazelle.xval.DICOMToXMLParser']}</ui:define>
                            <br/>
                            <h:selectOneMenu
                                    value="#{xvalidatorEditorManager.validatorConfiguration.dicomLibrary}"
                                    id="dicomInput" styleClass="form-control gzl-form-control gzl-select-text">
                                <f:selectItems value="#{xvalidatorEditorManager.getDicomLibraries()}"/>
                            </h:selectOneMenu>
                            <s:span styleClass="fa fa-info help-block">
                                <h:outputText
                                        value=" #{messages['net.ihe.gazelle.xval.IfYouIntentToUseDICOMFilesPleaseProvideTheLibrar']}"/>
                            </s:span>
                        </s:decorate>
                        <s:decorate template="/layout/form/_edit.xhtml">
                            <ui:param name="id" value="svsurlInput"/>
                            <ui:define name="label">#{messages['net.ihe.gazelle.xval.SVSRepositoryURL']}</ui:define>
                            <h:inputText
                                    value="#{xvalidatorEditorManager.validatorConfiguration.valueSetProviderUrl}"
                                    id="svsurlInput" styleClass="form-control"/>
                            <s:span styleClass="fa fa-info help-block">
                                <h:outputText
                                        value=" #{messages['net.ihe.gazelle.xval.IfYouDoNotWantToUseTheDefaultRepositoryURLProvid']}"/>
                                <h:outputText
                                        value=" #{messages['net.ihe.gazelle.xval.DefaultValue']} #{xvalidatorEditorManager.getSvsRepositoryDefaultUrl()}"/>
                            </s:span>
                        </s:decorate>
                        <s:div id="namespaceDiv">
                            <dl>
                                <s:decorate template="/layout/display/_display.xhtml" id="nsList">
                                    <ui:define name="label">#{messages['net.ihe.gazelle.xval.XMLNamespaces']}
                                    </ui:define>
                                    <a4j:repeat value="#{xvalidatorEditorManager.getValidatorNamespaces()}" var="ns">
                                        <div class="row">
                                            <h:outputText value="#{ns.toString()}"/>
                                            <a4j:commandLink
                                                    actionListener="#{xvalidatorEditorManager.removeNamespace(ns)}"
                                                    immediate="true" render="nsList" execute="@this"
                                                    title="#{messages['net.ihe.gazelle.xval.RemoveNamespace']}">
                                                <s:span styleClass="fa fa-trash-o gzl-text-red"/>
                                            </a4j:commandLink>
                                        </div>
                                    </a4j:repeat>
                                </s:decorate>
                            </dl>
                            <div class="form-inline">
                                <ui:decorate template="/layout/form/_edit.xhtml">
                                    <ui:param name="id" value="prefixInput"/>
                                    <ui:define name="label">#{messages['net.ihe.gazelle.xval.Prefix']}</ui:define>
                                    <h:inputText value="#{xvalidatorEditorManager.namespaceToAdd.prefix}"
                                                 id="prefixInput"
                                                 styleClass="form-control"/>
                                </ui:decorate>
                                <ui:decorate template="/layout/form/_edit.xhtml">
                                    <ui:param name="id" value="nsInput"/>
                                    <ui:define name="label">#{messages['net.ihe.gazelle.xval.NamespaceURI']}</ui:define>
                                    <rich:autocomplete autofill="true" style="width: 300px;"
                                                       layout="list" mode="client"
                                                       value="#{xvalidatorEditorManager.namespaceToAdd.uri}"
                                                       autocompleteList="#{xvalidatorEditorManager.getAlreadyUsedNamespaceUri()}"
                                                       id="nsInput"
                                                       selectFirst="true"/>
                                </ui:decorate>
                                <span style="width: 10px;"/>
                                <a4j:commandButton value="#{messages['net.ihe.gazelle.xval.Add']}"
                                                   actionListener="#{xvalidatorEditorManager.addNamespaceToList()}"
                                                   render="namespaceDiv" styleClass="gzl-btn-green"/>
                            </div>
                            <s:span styleClass="fa fa-info help-block">
                                <h:outputText
                                        value=" #{messages['net.ihe.gazelle.xval.PleaseDeclareHereTheXMLNamespacesUsedInYourXPath']}"/>
                            </s:span>
                        </s:div>
                        <ui:define name="panel_footer">
                            <a4j:commandButton value="#{messages['net.ihe.gazelle.xval.Save']}"
                                               actionListener="#{xvalidatorEditorManager.save()}"
                                               styleClass="gzl-btn-green"
                                               render="configurationPanel"/>
                        </ui:define>
                    </ui:decorate>
                </h:form>
                <br/>

                <ui:decorate template="/layout/panels/_panel_title_id.xhtml">
                    <ui:param name="panel_id" value="validatedObjectsPanel"/>
                    <ui:define name="panel_title">
                        <h:outputText value="#{messages['net.ihe.gazelle.xval.Inputs']}"/>
                    </ui:define>
                    <h:form id="newInputForm">
                        <a4j:commandButton value="#{messages['net.ihe.gazelle.xval.AddAnInput']}"
                                           styleClass="gzl-btn-green"
                                           actionListener="#{xvalidatorEditorManager.initializeValidatorInput()}"
                                           rendered="#{xvalidatorEditorManager.selectedValidatorInput == null}"
                                           render="newInputForm"/>
                        <s:decorate template="/layout/panels/_panel_title.xhtml" id="newInputPanel"
                                    rendered="#{xvalidatorEditorManager.selectedValidatorInput != null}">
                            <ui:param name="panel_id" value="newValidatedObjectsPanel"/>
                            <ui:define name="panel_title">
                                <h:outputText value="#{messages['net.ihe.gazelle.xval.AddAnInput']}"/>
                            </ui:define>
                            <a4j:commandButton value="#{messages['net.ihe.gazelle.xval.CreateANewInput']}"
                                               actionListener="#{xvalidatorEditorManager.setCreateANewInput(true)}"
                                               styleClass="gzl-btn-green"
                                               rendered="#{not xvalidatorEditorManager.createANewInput}"
                                               immediate="true" render="newInputPanel"/>
                            <a4j:commandButton value="#{messages['net.ihe.gazelle.xval.SelectAnInput']}"
                                               actionListener="#{xvalidatorEditorManager.setCreateANewInput(false)}"
                                               styleClass="gzl-btn-green"
                                               rendered="#{xvalidatorEditorManager.createANewInput}"
                                               immediate="true"
                                               render="newInputPanel"/>
                            <br/>
                            <s:div id="newInput" rendered="#{xvalidatorEditorManager.createANewInput}">
                                <s:decorate template="/layout/form/_edit.xhtml">
                                    <ui:param name="id" value="fileTypeInput"/>
                                    <ui:define name="label">#{messages['net.ihe.gazelle.xval.FileType']}
                                    </ui:define>
                                    <br/>
                                    <h:selectOneMenu
                                            value="#{xvalidatorEditorManager.selectedValidatorInput.referencedObject.objectType}"
                                            required="true" id="fileTypeInput" styleClass="form-control gzl-form-control gzl-select-text"
                                            requiredMessage="The file type is a mandatory field">
                                        <f:selectItems value="#{xvalidatorEditorManager.objectTypes}"/>
                                        <a4j:ajax event="change" render="newInputPanel"/>
                                    </h:selectOneMenu>
                                </s:decorate>
                                <s:decorate template="/layout/form/_edit.xhtml">
                                    <ui:param name="id" value="inputKeywordInput"/>
                                    <ui:define name="label">#{messages['net.ihe.gazelle.xval.Keyword']}
                                    </ui:define>
                                    <h:inputText
                                            value="#{xvalidatorEditorManager.selectedValidatorInput.referencedObject.keyword}"
                                            required="true" requiredMessage="The keyword is a mandatory field"
                                            styleClass="form-control" id="inputKeywordInput"
                                            validator="#{xvalidatorEditorManager.validateReferencedObjectKeyword}"/>
                                </s:decorate>
                                <s:decorate template="/layout/form/_edit.xhtml"
                                            rendered="#{xvalidatorEditorManager.selectedValidatorInput.isXml()}">
                                    <ui:param name="id" value="xsdInput"/>
                                    <ui:define name="label">#{messages['net.ihe.gazelle.xval.XSDLocation']}
                                    </ui:define>
                                    <h:inputText
                                            value="#{xvalidatorEditorManager.selectedValidatorInput.referencedObject.xsdLocation}"
                                            size="100" maxlength="255" id="xsdInput" styleClass="form-control"/>
                                </s:decorate>
                                <s:decorate template="/layout/form/_edit.xhtml">
                                    <ui:param name="id" value="inputdescInput"/>
                                    <ui:define name="label">#{messages['net.ihe.gazelle.xval.Description']}
                                    </ui:define>
                                    <h:inputTextarea
                                            value="#{xvalidatorEditorManager.selectedValidatorInput.referencedObject.description}"
                                            required="true" id="inputdescInput" styleClass="form-control"
                                            requiredMessage="The description is a mandatory field"
                                            style="resize:both;"/>
                                </s:decorate>
                            </s:div>
                            <s:decorate template="/layout/form/_edit.xhtml"
                                        rendered="#{not xvalidatorEditorManager.createANewInput}">
                                <ui:param name="id" value="objectInput"/>
                                <ui:define name="label">#{messages['net.ihe.gazelle.xval.Input']}</ui:define>
                                <br/>
                                <h:selectOneMenu
                                        value="#{xvalidatorEditorManager.selectedValidatorInput.referencedObject}"
                                        required="true" id="objectInput" styleClass="form-control gzl-form-control gzl-select-text">
                                    <s:selectItems
                                            value="#{xvalidatorEditorManager.getAvailableReferencedObjects()}"
                                            var="ro" label="#{ro.objectType.value} - #{ro.description}"
                                            noSelectionLabel="#{messages['net.ihe.gazelle.xval.PleaseSelect']}"/>
                                </h:selectOneMenu>
                            </s:decorate>
                            <s:decorate template="/layout/form/_edit.xhtml">
                                <ui:param name="id" value="msgType"/>
                                <ui:define name="label">#{messages['net.ihe.gazelle.xval.Type']}</ui:define>
                                <br/>
                                <h:selectOneMenu value="#{xvalidatorEditorManager.selectedValidatorInput.messageType}" required="true"
                                                 requiredMessage="Please select a message type for this input"
                                                 styleClass="form-control gzl-form-control gzl-select-text" id="msgType">
                                    <f:selectItems value="#{xvalidatorEditorManager.getMsgTypes()}"/>
                                </h:selectOneMenu>
                            </s:decorate>
                            <s:decorate template="/layout/form/_edit.xhtml">
                                <ui:param name="id" value="minInput"/>
                                <ui:define name="label">#{messages['net.ihe.gazelle.xval.CardinalityMin']}
                                </ui:define>
                                <rich:inputNumberSpinner
                                        value="#{xvalidatorEditorManager.selectedValidatorInput.minQuantity}"
                                        step="1" id="minInput"
                                        minValue="0"/>
                            </s:decorate>
                            <s:decorate template="/layout/form/_edit.xhtml">
                                <ui:param name="id" value="maxInput"/>
                                <ui:define name="label">#{messages['net.ihe.gazelle.xval.CardinalityMax']}
                                </ui:define>
                                <rich:inputNumberSpinner
                                        value="#{xvalidatorEditorManager.selectedValidatorInput.maxQuantity}"
                                        step="1" id="maxInput"
                                        minValue="-1"/>
                                <s:span styleClass="fa fa-info help-block">
                                    <h:outputText
                                            value="#{messages['net.ihe.gazelle.xval.Use1ToSetMaxCardinalityAsUnbounded']}"/>
                                </s:span>
                            </s:decorate>
                            <a4j:commandButton value="#{messages['net.ihe.gazelle.xval.Add']}"
                                               styleClass="gzl-btn-green"
                                               actionListener="#{xvalidatorEditorManager.addValidatorInput()}"
                                               render="newInputForm,validatorInputsForm"/>
                        </s:decorate>
                    </h:form>
                    <br/>
                    <h:form id="validatorInputsForm">
                        <s:decorate template="/xvalidation/common/validatorInputsTable.xhtml">
                            <ui:param name="inputs" value="#{xvalidatorEditorManager.validatorInputs}"/>
                            <ui:define name="actionButtons">
                                <a4j:commandLink styleClass="action"
                                                 title="#{messages['net.ihe.gazelle.xval.DisplayReferencedObject']}"
                                                 id="displayReferencedObject"
                                                 action="#{xvalidatorEditorManager.redirectToReferencedObjectDoc(input)}">
                                    <s:span styleClass="gzl-icon-search"/>
                                </a4j:commandLink>
                                <a4j:commandLink id="editInput"
                                                 title="#{messages['net.ihe.gazelle.xval.EditInput']}"
                                                 oncomplete="jq162('#updateInputPanel').modal('show');"
                                                 render="updateInputPanelContent updateInputForm"
                                                 styleClass="action"
                                                 actionListener="#{validatorInputUpdateManager.setInput(input)}">
                                    <s:span styleClass="fa fa-pencil gzl-text-blue"/>
                                </a4j:commandLink>
                                <a4j:commandLink styleClass="action"
                                                 title="#{messages['net.ihe.gazelle.xval.RemoveInput']}"
                                                 id="removeInputImg"
                                                 rendered="#{xvalidatorEditorManager.validator.isUnderDevelopment() or xvalidatorEditorManager.validator.isUnderMaintenance()}"
                                                 render="deleteInputPopupContent deleteInputPopupButtons"
                                                 oncomplete="jq162('#deleteInputPopup').modal('show');"
                                                 actionListener="#{xvalidatorEditorManager.setSelectedValidatorInput(input)}">
                                    <s:span styleClass="fa fa-trash-o gzl-text-red"/>
                                </a4j:commandLink>
                            </ui:define>
                        </s:decorate>
                    </h:form>
                </ui:decorate>
                <br/>

                <ui:decorate template="/layout/panels/_panel_title_id.xhtml">
                    <ui:param name="panel_id" value="rulesPanel"/>
                    <ui:define name="panel_title">
                        <h:outputText value="#{messages['net.ihe.gazelle.xval.Rules']}"/>
                    </ui:define>
                    <h:form id="addRuleForm">
                        <a4j:commandButton value="#{messages['net.ihe.gazelle.xval.AddARule']}"
                                           styleClass="gzl-btn-green"
                                           action="#{xvalidatorEditorManager.addRule()}"/>
                        <br/>
                        <s:decorate template="/xvalidation/common/rulesTable.xhtml">
                            <ui:param name="id" value="direct"/>
                            <ui:param name="rules" value="#{xvalidatorEditorManager.rules}"/>
                            <ui:param name="displayRuleStatusColumn" value="true"/>
                            <ui:define name="actionButtons">
                                <a4j:commandLink id="editRule"
                                                 title="#{messages['net.ihe.gazelle.xval.EditRule']}"
                                                 styleClass="action" rendered="#{not rule.isDeprecated()}"
                                                 oncomplete="jq162('#updateRulePanel').modal('show');"
                                                 render="updateRulePanelContent updateForm"
                                                 actionListener="#{ruleUpdateManager.setRule(rule)}">
                                    <s:span styleClass="fa fa-pencil gzl-text-blue"/>
                                </a4j:commandLink>
                                <a4j:commandLink id="copyRule" title="#{messages['net.ihe.gazelle.xval.DuplicateRule']}"
                                                 styleClass="action" rendered="#{not rule.isDeprecated()}"
                                                 action="#{ruleUpdateManager.duplicateRule(rule)}">
                                    <s:span styleClass="fa fa-files-o gzl-text-blue"/>
                                </a4j:commandLink>
                                <a4j:commandLink id="restoreRule"
                                                 title="#{messages['net.ihe.gazelle.xval.RestoreRule']}" styleClass="action"
                                                 rendered="#{rule.isDeprecated()}"
                                                 oncomplete="jq162('#restoreRulePanel').modal('show');"
                                                 render="restoreRulePanelContent restoreRulePanelButtonsForm"
                                                 actionListener="#{ruleUpdateManager.setRule(rule)}">
                                    <s:span styleClass="gzl-icon-undo"/>
                                </a4j:commandLink>
                                <a4j:commandLink id="deprecateRule"
                                                 title="#{messages['net.ihe.gazelle.xval.MarkAsDeprecatedinactive']}"
                                                 styleClass="action" rendered="#{not rule.isDeprecated()}"
                                                 oncomplete="jq162('#deprecateRulePanel').modal('show');"
                                                 render="deprecateRulePanelContent"
                                                 actionListener="#{ruleUpdateManager.setRule(rule)}">
                                    <s:span styleClass="fa fa-trash-o gzl-text-red"/>
                                </a4j:commandLink>
                            </ui:define>
                        </s:decorate>
                    </h:form>
                    <h:form id="inheritedRuleForm">
                        <h2>#{messages['net.ihe.gazelle.xval.InheritedRules']}</h2>
                        <s:decorate template="/xvalidation/common/rulesTable.xhtml" id="inheritedRulesDecorate">
                            <ui:param name="id" value="inherited"/>
                            <ui:param name="rules" value="#{xvalidatorEditorManager.getInheritedRules()}"/>
                            <ui:param name="displayRuleStatusColumn" value="true"/>
                        </s:decorate>
                    </h:form>
                </ui:decorate>
            </s:div>
        </s:div>
        <ui:include src="/xvalidation/admin/availableValidatorPanel.xhtml"/>
        <ui:include src="/xvalidation/admin/updateInputPanel.xhtml"/>
        <ui:include src="/xvalidation/admin/updateRulePanel.xhtml"/>
        <ui:include src="/xvalidation/admin/deleteInputPanel.xhtml"/>
        <ui:include src="/xvalidation/admin/restoreRulePanel.xhtml"/>
        <ui:include src="/xvalidation/admin/deprecateRulePanel.xhtml">
            <ui:param name="idsToRerender" value="rulesTableForm_direct"/>
        </ui:include>
    </ui:define>
</ui:composition>
